## expcore.gui.elements.progress-bar module

Gui element define for progress bars [[

### Dependencies

expcore.gui.core
expcore.gui.prototype
utils.global
utils.game

### Functions

ProgressBar.set_maximum(element, amount) | Sets the maximum value that represents the end value of the progress bar
ProgressBar.increment(element[, amount=1]) | Increases the value of the progressbar, if a define is given all of its instances have incremented
ProgressBar.decrement(element[, amount=1]) | Decreases the value of the progressbar, if a define is given all of its instances have decremented
ProgressBar.new_progressbar([name]) | Creates a new progressbar element define
ProgressBar._prototype:set_default_maximum(amount) | Sets the maximum value that represents the end value of the progress bar
ProgressBar._prototype:use_count_down([state=true]) | Will set the progress bar to start at 1 and trigger when it hits 0
ProgressBar._prototype:increment([amount=1][, category]) | Increases the value of the progressbar
ProgressBar._prototype:increment_filtered([amount=1], filter) | Increases the value of the progressbar, if the filter condition is met, does not work with store
ProgressBar._prototype:decrement([amount=1][, category]) | Decreases the value of the progressbar
ProgressBar._prototype:decrement_filtered([amount=1], filter) | Decreases the value of the progressbar, if the filter condition is met, does not work with store
ProgressBar._prototype:add_element(element[, maximum]) | Adds an element into the list of instances that will are waiting to complete, does not work with store note use store if you want persistent data, this only stores the elements not the values which they have
ProgressBar._prototype:reset_element(element) | Resets an element, or its store, to be back at the start, either 1 or 0
ProgressBar._prototype:event_counter([filter]) | Event handler factory that counts up by 1 every time the event triggers, can filter which elements have incremented
ProgressBar._prototype:event_countdown([filter]) | Event handler factory that counts down by 1 every time the event triggers, can filter which elements have decremented

### Dependencies

# expcore.gui.core
# expcore.gui.prototype
# utils.global
# utils.game

### Functions

# ProgressBar.set_maximum(element, amount)

  Sets the maximum value that represents the end value of the progress bar

  Parameters:
  - element : (LuaGuiElement or string) either a gui element or a registered define
  - amount : (number) the amount to have set as the maximum
# ProgressBar.increment(element[, amount=1])

  Increases the value of the progressbar, if a define is given all of its instances have incremented

  Parameters:
  - element : (LuaGuiElement or string) either a gui element or a registered define
  - amount : (number) the amount to increase the progressbar by (default: 1)
# ProgressBar.decrement(element[, amount=1])

  Decreases the value of the progressbar, if a define is given all of its instances have decremented

  Parameters:
  - element : (LuaGuiElement or string) either a gui element or a registered define
  - amount : (number) the amount to decrease the progressbar by (default: 1)
# ProgressBar.new_progressbar([name])

  Creates a new progressbar element define

  Parameters:
  - name : (string) the optional debug name that can be added (optional)
  Returns:
  - (table) the new progressbar element define
# ProgressBar._prototype:set_default_maximum(amount)

  Sets the maximum value that represents the end value of the progress bar

  Parameters:
  - amount : (number) the amount to have set as the maximum
  Returns:
  - (table) the define to allow chaining
# ProgressBar._prototype:use_count_down([state=true])

  Will set the progress bar to start at 1 and trigger when it hits 0

  Parameters:
  - state : (boolean) when true the bar will start filled, to be used with decrease (default: true)
  Returns:
  - (table) the define to allow chaining
# ProgressBar._prototype:increment([amount=1][, category])

  Increases the value of the progressbar

  Parameters:
  - amount : (number) the amount to increase the progressbar by (default: 1)
  - category : (string) the category that is used with a store (optional)
# ProgressBar._prototype:increment_filtered([amount=1], filter)

  Increases the value of the progressbar, if the filter condition is met, does not work with store

  Parameters:
  - amount : (number) the amount to increase the progressbar by (default: 1)
  - filter : (function) the filter to be used
# ProgressBar._prototype:decrement([amount=1][, category])

  Decreases the value of the progressbar

  Parameters:
  - amount : (number) the amount to decrease the progressbar by (default: 1)
  - category : (string) the category that is used with a store (optional)
# ProgressBar._prototype:decrement_filtered([amount=1], filter)

  Decreases the value of the progressbar, if the filter condition is met, does not work with store

  Parameters:
  - amount : (number) the amount to decrease the progressbar by (default: 1)
  - filter : (function) the filter to be used
# ProgressBar._prototype:add_element(element[, maximum])

  Adds an element into the list of instances that will are waiting to complete, does not work with store note use store if you want persistent data, this only stores the elements not the values which they have

  Parameters:
  - element : (LuaGuiElement) the element that you want to add into the waiting to complete list
  - maximum : (number) the maximum for this element if not given the default for this define is used (optional)
# ProgressBar._prototype:reset_element(element)

  Resets an element, or its store, to be back at the start, either 1 or 0

  Parameters:
  - element : (LuaGuiElement) the element that you want to reset the progress of
# ProgressBar._prototype:event_counter([filter])

  Event handler factory that counts up by 1 every time the event triggers, can filter which elements have incremented

  Parameters:
  - filter : (function) when given will use filtered increment (optional)
  Returns:
  - (function) the event handler
# ProgressBar._prototype:event_countdown([filter])

  Event handler factory that counts down by 1 every time the event triggers, can filter which elements have decremented

  Parameters:
  - filter : (function) when given will use filtered decrement (optional)
  Returns:
  - (function) the event handler